<?php
class TListeSimple {                    // classe de base permettant de grer
  var $liste = array();    
var $liste1 = array();    
  function clear() {
    array_splice($this->liste,          // remplacer dans         $this->liste
                 0,                     //  partir de l'indice   0
                 count($this->liste));  // tous les lments ...  par rien
  }

  function init($valeurs) {
    $this->clear();

    foreach($valeurs as $key =>$valeur)
    {  $this->liste[] = $valeur;
	  $this->liste1[] = $key;
	  }
	  
  }

  function add($valeur) {
    $this->liste[] = $valeur;
  }

  function insert($i, $valeur) {
    array_splice($this->liste,      // remplacer dans              $this->liste
                 $i,                //  partir de l'indice        $i
                 0,                 // les O (!) lments
                 array($valeur));   // par le tableau d'un lment [ $valeur ]
  }

  function delete($i) {
    array_splice($this->liste,      // remplacer dans              $this->liste
                 $i,                //  partir de l'indice        $i
                 1);                // un lment ... par rien
  }

}

// ----------------------------------------------------------------------------

class TListeCouleur extends TListeSimple{
  var $couleur;
  var $legende;
  var $histo;
  var $haut;
  var $droite;
  var $taille;
  var $phaut;  // ne pas changer cette valeur manuellement

  function init($coul, $leg, $valeurs) {
    parent::init($valeurs);
    $this->couleur = $coul;
    $this->legende = $leg;
  }

  // cette fonction a t crite dans le but de tester les affectations d'adresse
  
  function calc_haut_droite($i) {
    $H = $this->histo;      // "raccourci"
    $n = count($H->liste);  // nombre de niveaux de l'histogramme
	$rapport = $H->hauteur_pixels / $H->hauteur_reelle;
    
	$this->phaut = $H->top 
	              +($H->vmax * $rapport)
	              +$H->v_decalage*($n-1 -$i);
				  
    $m = count($this->liste);
  
    for ($j=0; $j<$m; $j++) {
      $this->droite[$j] = $H->left +$j*$H->TailleStatBloc +$i*$H->h_decalage;
      $this->taille[$j] = round(abs($this->liste[$j])*$rapport);
		
      if ($this->liste[$j]>=0)
        $this->haut[$j] = $this->phaut - $this->taille[$j];
      else
        $this->haut[$j] = $this->phaut;
    }
  }
}

// ---------------------------------------------------------------------------

class THistogramme extends TListeSimple{
  var $top;
  var $left;
  var $hauteur_pixels;  // hauteur en pixel de la plus grande valeur de l'histogramme 
  var $epaisseur;   // epaisseur d'une barre de l'histogramme
  var $h_decalage;  // dcalage horizontal en pixels entre le graphe n et le graphe n-1
  var $v_decalage;  // dcalage vertical en pixels entre le graphe n et le graphe n-1
  var $espace;
  var $prefixe;
  var $hauteur_reelle;
  var $TailleStatBloc;
  var $vmin;
  var $vmax;
  
  function add(&$valeur) {
  //print_r($valeur);
    $valeur->histo = &$this;
    $this->liste[] = &$valeur;  
  }

  function insert($i, &$valeur) {
    $valeur->histo = &$this;
    array_splice($this->liste,      // remplacer dans              $this->liste 
                 $i,                //  partir de l'indice        $i
                 0,                 // les O (!) lments
                 array(&$valeur));  // par le tableau d'un lment [ $valeur ]
  }
 
  function Histogramme() { // constructeur
    $this->prefixe = "";
  }

  function calculerhauteurmax () {
    $this->vmin = $this->liste[0]->liste[0];
    $this->vmax = $this->vmin;
    $n = count($this->liste);  // nombre de "ListeSimpleCouleur"

    for ($i=0; $i<$n; $i++) {
      $m = count($this->liste[$i]->liste);
  
      for ($j=0; $j<$m; $j++) {
        if ($this->vmin>$this->liste[$i]->liste[$j]) $this->vmin = $this->liste[$i]->liste[$j];
        if ($this->vmax<$this->liste[$i]->liste[$j]) $this->vmax = $this->liste[$i]->liste[$j];
      }
    }

    if (($this->vmin<0) and ($this->vmax>0)) {
      $this->hauteur_reelle = $this->vmax - $this->vmin;
	}
    elseif ($this->vmin<0) {
	  $this->vmax = 0;
      $this->hauteur_reelle = -$this->vmin;
    }
	else {
	  $this->vmin = 0;
      $this->hauteur_reelle = $this->vmax;
    }
  }

  function creercouches() {
    $n = count($this->liste);  // nombre de "ListeSimpleCouleur"
    $this->TailleStatBloc = $this->epaisseur +($this->h_decalage)*($n-1) +$this->espace;

    echo "<style type=text/css>\n";

    for ($i=0; $i<$n; $i++) {               
      $this->liste[$i]->calc_haut_droite($i);

      $m = count($this->liste[$i]->liste);
  
      for ($j=0; $j<$m; $j++) {
        echo '#couches' .$this->prefixe 
                        .$i .'x' .$j
                        .'{position: absolute; '
                        .'left:' . $this->liste[$i]->droite[$j] .'px; '
                        .'top:'  . $this->liste[$i]->haut[$j] .'px; '
                        .'z-index=' .($j +($n-1-$i)*$n) .';'
                        .'}';
      }
    }

    echo "</style>\n";
  }

  function dessiner() {
    for ($i=count($this->liste)-1; $i>=0; $i--) {
      $m = count($this->liste[$i]->liste);

      for ($j=0; $j<$m; $j++) {
        echo '<div id=couches' .$this->prefixe .$i .'x' .$j ." >".
		"<div >".$this->liste[$i]->liste[$j]."</div>";
        echo '<img src="' .$this->liste[$i]->couleur .'" '
                          .'width='  .$this->epaisseur .'px '
                          .'height=' .($this->liste[$i]->taille[$j]).'px '
                          .'alt="('.$this->liste[$i]->legende.') '
                          .$this->liste[$i]->liste[$j]
                          .'" border=0 vspace=0 hspace=0>';
        echo '</div>';
      }
    }
  }
  
  function creercoucheslegende() {
    $n = count($this->liste);  // nombre de "ListeSimpleCouleur"

    echo "<style type=text/css>\n";

    for ($i=0; $i<$n; $i++) {               
      $m = count($this->liste[$i]->liste);
	  $topi = $this->top +24 +$this->hauteur_pixels +$i*16 + $n*$this->v_decalage;
  
      for ($j=0; $j<$m; $j++) {
        echo '#valeurs' .$this->prefixe 
                        .$i .'x' .$j
                        .'{position: absolute; '
                        .'left:' . ($this->left +$j*$this->TailleStatBloc) .'px; '
                        .'top:'  . ($topi).'px; '
                        .'font-family:arial, helvetica; '
                        .'font-face:arial; '
                        .'font-size: 8pt; '
                        .'}'."\n";
      }
    }

    echo "</style>\n";
  }

  function dessinerlegende() {
  
    for ($i=count($this->liste)-1; $i>=0; $i--) {
      $m = count($this->liste[$i]->liste);

      for ($j=0; $j<$m; $j++) {
        echo '<div id=valeurs' .$this->prefixe .$i .'x' .$j .">"."\n";
        echo"<b>". $this->liste[$i]->liste1[$j] ."</b>"."\n";
		//echo("i=".$i."j=".$j."\n" );
        echo '</div>';
      }
    }
  }

  function run($legende=false) {
    $this->calculerhauteurmax();
    $this->creercouches();

    if ($legende==true) $this->creercoucheslegende();
    
    $this->dessiner();

    if ($legende==true) $this->dessinerlegende();
  }
}

// ---------------------------------------------------------------------------

?>
